; Copyright (C) 1997, 1998, 1999 Kevin Fu <fubob@mit.edu>
; Copyright (C) 1997, 1998, 1999 Ben Adida <ben@mit.edu>
; Copyright (C) 1997, 1998, 1999 Rodrigo Leroux
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License as
; published by the Free Software Foundation; either version 2, or (at
; your option) any later version.
;
; This program is distributed in the hope that it will be useful, but
; WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
; General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
; USA

;------------------------
; Define macros. Each  macro takes 14 or 15 cycles depending on carry.

ADD_KX	MACRO	A1,K
	MOV	A,BB+A1
	ADD	A,BB-A1+NT2-1
	RRC	A	; divide by 2
	MOV	B,#K
	MUL	AB
	MOV	A,R7	; ignore lsbyte
	ADD	A,B
	MOV	R7,A
	JNC	$+3	; propagate carry
	INC	R6
	ENDM

SUB_KX	MACRO	A1,K
	MOV	A,BB+A1
	ADD	A,BB-A1+NT2-1
	RRC	A	; divide by 2
	MOV	B,#K
	MUL	AB
	MOV	A,R7	; ignore lsbyte
	SUBB	A,B	; carry is cleared by MUL AB
	MOV	R7,A	; propagate carry
	JNC	$+3
	DEC	R6
	ENDM

